from utils.db_handling.db_access import DbRequirementsAccessor

rule download_using_direct_dl:
    output:
        protected("{database}/{version}/direct_dl/{filename}")
    message:
        f"downloading file: {'{output[0]}'}"
    version: "0.1"
    params:
        url=lambda w: DbRequirementsAccessor(w.database, w.version).get_url_for_file(w.filename)
    shell:
        """
        wget -nv -O "{output}" "{params.url}"
        """

rule download_using_emapper_dl:
    output:
        # protecting emapper data results in snakemake crash, probably due to large number of files
        directory("{database}/{version}/emapper_dl/{directory}")
    message:
        f"downloading file using emapper: {'{output[0]}'}"
    conda:
        "../../envs/emapper.yaml"
    shell:
        """
        mkdir -p "{output[0]}";
        download_eggnog_data.py -y -f --data_dir "{output[0]}" euk bact arch viruses;
        """
